<?php
  
require_once('interface.Validator.php');

abstract class PropertyObject implements Validator {
   
    protected $propertyTable = array();     //Almacena pares de nombre y valor que conectan propiedades a nombres de campo de base de datos
                                           
    protected $changedProperties = array(); //Lista de propiedades que se han modificado
   
    protected $data;                        //Datos realeas de base de datos
                                           
    protected $errors = array();            //Errores de validacin que pueden haberse producido                                          
   
    public function __construct($arData) {
      $this->data = $arData;
    }
	
	function __getProperty () {
		return $this->propertyTable;
	}
	
	function __getChanged () {
		return $this->changedProperties;
	}
	
	function __getData () {
		return $this->data;
	}
   
    function __get($propertyName) {
      if(!array_key_exists($propertyName, $this->propertyTable))
        throw new Exception("Invalid property \"$propertyName\"!");
     
      if(method_exists($this, 'get' . $propertyName)) {
        return call_user_func(array($this, 'get' . $propertyName));
      } else {
        return $this->data[$this->propertyTable[$propertyName]];
      }
    }
 
    function __set($propertyName, $value) {
      if(!array_key_exists($propertyName, $this->propertyTable))
        throw new Exception("Invalid property En el SET \"$propertyName\"!");
     
      if(method_exists($this, 'set' . $propertyName)) {
        return call_user_func(
                  array($this, 'set' . $propertyName),
                  $value
                   );
      } else {
       
        //If the value of the property really has changed
        //and it's not already in the changedProperties array,
        //add it. 
        if($this->propertyTable[$propertyName] != $value &&
           !in_array($propertyName, $this->changedProperties)) {
          $this->changedProperties[] = $propertyName;
        }
       
        //Now set the new value
        $this->data[$this->propertyTable[$propertyName]] = $value;
       //print_r ($this->data);
      }
    }
     
   function validate()
	  {}
 
  }
?>
