<?php

class Ventas extends PropertyObject {
	
	public function __construct ($ventasID) {
		
		if (isset($ventasID)) {		
			$arData = DataManagerVentas::getVentasData ($ventasID);
			parent::__construct ($arData);
		}
		
		$this->propertyTable ['id_venta'] = 'id04_ventas';
		$this->propertyTable ['id_generado'] = 'id_generado';
		$this->propertyTable ['id_provincia'] = '06_provincias_id06_provincias';
		$this->propertyTable ['id_estado_venta'] = '041_estadoVenta_id041_estadoVenta';
		$this->propertyTable ['id_forma_envio'] = '042_formasEnvio_id042_formasEnvio';
		$this->propertyTable ['nombre_cliente'] = 'nombre_cliente';
		$this->propertyTable ['apellidos_cliente'] = 'apellidos_cliente';
		$this->propertyTable ['dni_cliente'] = 'dni_cliente';
		$this->propertyTable ['mail_cliente'] = 'mail_cliente';
		$this->propertyTable ['direccion_cliente'] = 'direccion_cliente';
		$this->propertyTable ['ciudad_cliente'] = 'ciudad_cliente';
		$this->propertyTable ['telefono_cliente'] = 'telefono_cliente';
		$this->propertyTable ['forma_de_pago'] = 'forma_de_pago';
		$this->propertyTable ['codigo_postal'] = 'codigo_postal';
		$this->propertyTable ['codigo_transferencia'] = 'codigo_transferencia';
		$this->propertyTable ['precio_total'] = 'precio_total';
		$this->propertyTable ['iva'] = 'iva';
		$this->propertyTable ['fecha'] = 'fecha';
		$this->propertyTable ['enviado'] = 'enviado';

	}
	
	public function del () {
			DataManagerVentas:: deleteVentas ($this);									
	}
		
	
	public function __destruct () {
			
		if (sizeof($this->changedProperties)){
			if ($this->data ['id04_ventas']) {
				DataManagerVentas::updateVentas ($this);
			}
			else  {
				//echo "en el destructor de Ventas";
				DataManagerVentas::createVentas ($this);
			}
			
		}			
	}

}

?>